<a id="mypy-boto3-route53-recovery-readiness"></a>

# mypy-boto3-route53-recovery-readiness

[![PyPI - types-aiobotocore-route53-recovery-readiness](https://img.shields.io/pypi/v/types-aiobotocore-route53-recovery-readiness.svg?color=blue)](https://pypi.org/project/types-aiobotocore-route53-recovery-readiness)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-route53-recovery-readiness.svg?color=blue)](https://pypi.org/project/types-aiobotocore-route53-recovery-readiness)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-route53-recovery-readiness?color=blue)](https://pypistats.org/packages/types-aiobotocore-route53-recovery-readiness)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.Route53RecoveryReadiness 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/route53-recovery-readiness.html#Route53RecoveryReadiness)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-route53-recovery-readiness docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_route53_recovery_readiness/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-route53-recovery-readiness](#mypy-boto3-route53-recovery-readiness)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `Route53RecoveryReadiness`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `Route53RecoveryReadiness` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[route53-recovery-readiness]'

# Lite version does not provide session.create_client overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[route53-recovery-readiness]'

# standalone installation
python -m pip install types-aiobotocore-route53-recovery-readiness
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[route53-recovery-readiness]` in your environment:
  `python -m pip install 'types-aiobotocore[route53-recovery-readiness]'`

Both type checking and auto-complete should work for `Route53RecoveryReadiness`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[route53-recovery-readiness]` in your environment:
  `python -m pip install 'types-aiobotocore[route53-recovery-readiness]'`

Both type checking and auto-complete should work for `Route53RecoveryReadiness`
service. No explicit type annotations required, write your `aiobotocore` code
as usual. Auto-complete can be slow on big projects or if you have a lot of
installed `types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[route53-recovery-readiness]` in your environment:
  `python -m pip install 'types-aiobotocore[route53-recovery-readiness]'`
- Run `mypy` as usual

Type checking should work for `Route53RecoveryReadiness` service. No explicit
type annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[route53-recovery-readiness]` in your environment:
  `python -m pip install 'types-aiobotocore[route53-recovery-readiness]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `Route53RecoveryReadiness` service. No explicit
type annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`Route53RecoveryReadinessClient` provides annotations for
`session.create_client("route53-recovery-readiness")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_route53_recovery_readiness import Route53RecoveryReadinessClient

session = get_session()
async with session.create_client("route53-recovery-readiness") as client:
    client: Route53RecoveryReadinessClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_route53_recovery_readiness.paginator` module contains type
annotations for all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_route53_recovery_readiness import Route53RecoveryReadinessClient
from types_aiobotocore_route53_recovery_readiness.paginator import (
    GetCellReadinessSummaryPaginator,
    GetReadinessCheckResourceStatusPaginator,
    GetReadinessCheckStatusPaginator,
    GetRecoveryGroupReadinessSummaryPaginator,
    ListCellsPaginator,
    ListCrossAccountAuthorizationsPaginator,
    ListReadinessChecksPaginator,
    ListRecoveryGroupsPaginator,
    ListResourceSetsPaginator,
    ListRulesPaginator,
)

session = get_session()
async with session.create_client("route53-recovery-readiness") as client:
    client: Route53RecoveryReadinessClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        get_cell_readiness_summary_paginator: GetCellReadinessSummaryPaginator = client.get_paginator("get_cell_readiness_summary")
        get_readiness_check_resource_status_paginator: GetReadinessCheckResourceStatusPaginator = client.get_paginator("get_readiness_check_resource_status")
        get_readiness_check_status_paginator: GetReadinessCheckStatusPaginator = client.get_paginator("get_readiness_check_status")
        get_recovery_group_readiness_summary_paginator: GetRecoveryGroupReadinessSummaryPaginator = client.get_paginator("get_recovery_group_readiness_summary")
        list_cells_paginator: ListCellsPaginator = client.get_paginator("list_cells")
        list_cross_account_authorizations_paginator: ListCrossAccountAuthorizationsPaginator = client.get_paginator("list_cross_account_authorizations")
        list_readiness_checks_paginator: ListReadinessChecksPaginator = client.get_paginator("list_readiness_checks")
        list_recovery_groups_paginator: ListRecoveryGroupsPaginator = client.get_paginator("list_recovery_groups")
        list_resource_sets_paginator: ListResourceSetsPaginator = client.get_paginator("list_resource_sets")
        list_rules_paginator: ListRulesPaginator = client.get_paginator("list_rules")
    ```







### Literals

`types_aiobotocore_route53_recovery_readiness.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_route53_recovery_readiness.literals import (
    GetCellReadinessSummaryPaginatorName,
    GetReadinessCheckResourceStatusPaginatorName,
    GetReadinessCheckStatusPaginatorName,
    GetRecoveryGroupReadinessSummaryPaginatorName,
    ListCellsPaginatorName,
    ListCrossAccountAuthorizationsPaginatorName,
    ListReadinessChecksPaginatorName,
    ListRecoveryGroupsPaginatorName,
    ListResourceSetsPaginatorName,
    ListRulesPaginatorName,
    ReadinessType,
    ServiceName,
    PaginatorName,
)

def check_value(value: GetCellReadinessSummaryPaginatorName) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_route53_recovery_readiness.type_defs` module contains
structures and shapes assembled to typed dictionaries for additional type
checking.

```python
from types_aiobotocore_route53_recovery_readiness.type_defs import (
    CellOutputTypeDef,
    CreateCellRequestRequestTypeDef,
    CreateCellResponseTypeDef,
    CreateCrossAccountAuthorizationRequestRequestTypeDef,
    CreateCrossAccountAuthorizationResponseTypeDef,
    CreateReadinessCheckRequestRequestTypeDef,
    CreateReadinessCheckResponseTypeDef,
    CreateRecoveryGroupRequestRequestTypeDef,
    CreateRecoveryGroupResponseTypeDef,
    CreateResourceSetRequestRequestTypeDef,
    CreateResourceSetResponseTypeDef,
    DNSTargetResourceTypeDef,
    DeleteCellRequestRequestTypeDef,
    DeleteCrossAccountAuthorizationRequestRequestTypeDef,
    DeleteReadinessCheckRequestRequestTypeDef,
    DeleteRecoveryGroupRequestRequestTypeDef,
    DeleteResourceSetRequestRequestTypeDef,
    GetArchitectureRecommendationsRequestRequestTypeDef,
    GetArchitectureRecommendationsResponseTypeDef,
    GetCellReadinessSummaryRequestRequestTypeDef,
    GetCellReadinessSummaryResponseTypeDef,
    GetCellRequestRequestTypeDef,
    GetCellResponseTypeDef,
    GetReadinessCheckRequestRequestTypeDef,
    GetReadinessCheckResourceStatusRequestRequestTypeDef,
    GetReadinessCheckResourceStatusResponseTypeDef,
    GetReadinessCheckResponseTypeDef,
    GetReadinessCheckStatusRequestRequestTypeDef,
    GetReadinessCheckStatusResponseTypeDef,
    GetRecoveryGroupReadinessSummaryRequestRequestTypeDef,
    GetRecoveryGroupReadinessSummaryResponseTypeDef,
    GetRecoveryGroupRequestRequestTypeDef,
    GetRecoveryGroupResponseTypeDef,
    GetResourceSetRequestRequestTypeDef,
    GetResourceSetResponseTypeDef,
    ListCellsRequestRequestTypeDef,
    ListCellsResponseTypeDef,
    ListCrossAccountAuthorizationsRequestRequestTypeDef,
    ListCrossAccountAuthorizationsResponseTypeDef,
    ListReadinessChecksRequestRequestTypeDef,
    ListReadinessChecksResponseTypeDef,
    ListRecoveryGroupsRequestRequestTypeDef,
    ListRecoveryGroupsResponseTypeDef,
    ListResourceSetsRequestRequestTypeDef,
    ListResourceSetsResponseTypeDef,
    ListRulesOutputTypeDef,
    ListRulesRequestRequestTypeDef,
    ListRulesResponseTypeDef,
    ListTagsForResourcesRequestRequestTypeDef,
    ListTagsForResourcesResponseTypeDef,
    MessageTypeDef,
    NLBResourceTypeDef,
    PaginatorConfigTypeDef,
    R53ResourceRecordTypeDef,
    ReadinessCheckOutputTypeDef,
    ReadinessCheckSummaryTypeDef,
    RecommendationTypeDef,
    RecoveryGroupOutputTypeDef,
    ResourceResultTypeDef,
    ResourceSetOutputTypeDef,
    ResourceTypeDef,
    ResponseMetadataTypeDef,
    RuleResultTypeDef,
    TagResourceRequestRequestTypeDef,
    TargetResourceTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateCellRequestRequestTypeDef,
    UpdateCellResponseTypeDef,
    UpdateReadinessCheckRequestRequestTypeDef,
    UpdateReadinessCheckResponseTypeDef,
    UpdateRecoveryGroupRequestRequestTypeDef,
    UpdateRecoveryGroupResponseTypeDef,
    UpdateResourceSetRequestRequestTypeDef,
    UpdateResourceSetResponseTypeDef,
)

def get_structure() -> CellOutputTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-route53-recovery-readiness` version is the same as related
`boto3` version and follows
[PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation

All type annotations can be found in
[types-aiobotocore-route53-recovery-readiness docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_route53_recovery_readiness/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
